# *0.4.0*

Eight release of RainbowCake.

## What's new:

### Dagger artifact

Dagger related code has been moved to a separate artifact, which you can include the following way:

```groovy
implementation "co.zsmb:rainbow-cake-dagger:$rainbow_cake_version"
```

Some imports have also been changed to reflect this. Here's a quick table of what you'll need to migrate (should be just a quick search & replace, so no script this time):

| Original                                           | Replacement                                          |
| -------------------------------------------------- | ---------------------------------------------------- |
| `co.zsmb.rainbowcake.di.RainbowCakeComponent`      | `co.zsmb.rainbowcake.dagger.RainbowCakeComponent`    |
| `co.zsmb.rainbowcake.di.RainbowCakeModule`         | `co.zsmb.rainbowcake.dagger.RainbowCakeModule`       |
| `co.zsmb.rainbowcake.di.ViewModelKey`              | `co.zsmb.rainbowcake.dagger.ViewModelKey`            |
| `co.zsmb.rainbowcake.RainbowCakeApplication`       | `co.zsmb.rainbowcake.dagger.RainbowCakeApplication`  |
| `co.zsmb.rainbowcake.base.getViewModelFromFactory` | `co.zsmb.rainbowcake.dagger.getViewModelFromFactory` |

### Koin support

Why mess around with all that Dagger stuff? Because it's no longer the only game in town. You may now also use Koin 2.0 for your dependency injection needs with RainbowCake.

1. Include the new Koin artifact:

    ```groovy
    implementation "co.zsmb:rainbow-cake-koin:$rainbow_cake_version"
    ```  

2. Replace Dagger with Koin in your dependencies, here are some recommended artifacts:

    ```groovy
    def koin_version = '2.0.1'
    implementation "org.koin:koin-core:$koin_version"
    implementation "org.koin:koin-android:$koin_version"
    implementation "org.koin:koin-android-viewmodel:$koin_version"
    ```
    
3. Set up Koin. You won't need `@Inject` annotations any more, but you'll have to declare modules and start up your Koin (ideally, in your `Application`'s `onCreate` method). See the [getting started guide](https://insert-koin.io/docs/2.0/getting-started/android/) for more details.

Note: You may also use the two DI solutions within the same RainbowCake project simultaneously, for example if you're migrating a project piece by piece. Even shared ViewModels should work! 

### Proper license

The project is now licensed under Apache 2. One more step towards proper open source.

### Android Studio template updates

The screen template now has an option to generate new screens that are powered by Koin, and both the screen and ListAdapter templates now support AndroidX!
